# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui import api as traitsui

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

from tvtk.tvtk_classes.distance_representation import DistanceRepresentation


class DistanceRepresentation3D(DistanceRepresentation):
    """
    DistanceRepresentation3D - represent the DistanceWidget
    
    Superclass: DistanceRepresentation
    
    The DistanceRepresentation3D is a representation for the
    DistanceWidget. This representation consists of a measuring line
    (axis) and two HandleWidgets to place the end points of the line.
    Note that this particular widget draws its representation in 3d
    space, so the widget can be occluded.
    
    See Also:
    
    DistanceWidget DistanceRepresentation
    DistanceRepresentation2D
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkDistanceRepresentation3D, obj, update, **traits)
    
    maximum_number_of_ruler_ticks = traits.Trait(99, traits.Range(1, 2147483647, enter_set=True, auto_set=False), help=\
        """
        Set/Get the maximum number of ticks in ruler mode.
        """
    )
    def _maximum_number_of_ruler_ticks_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetMaximumNumberOfRulerTicks,
                        self.maximum_number_of_ruler_ticks)

    def get_point1_world_position(self, *args):
        """
        V.get_point1_world_position([float, float, float])
        C++: void GetPoint1WorldPosition(double pos[3])
        Methods to Set/Get the coordinates of the two points defining
        this representation. Note that methods are available for both
        display and world coordinates.
        """
        ret = self._wrap_call(self._vtk_obj.GetPoint1WorldPosition, *args)
        return ret

    def set_point1_world_position(self, *args):
        """
        V.set_point1_world_position([float, float, float])
        C++: void SetPoint1WorldPosition(double pos[3])
        Methods to Set/Get the coordinates of the two points defining
        this representation. Note that methods are available for both
        display and world coordinates.
        """
        ret = self._wrap_call(self._vtk_obj.SetPoint1WorldPosition, *args)
        return ret

    def get_point1display_position(self, *args):
        """
        V.get_point1display_position([float, float, float])
        C++: void GetPoint1DisplayPosition(double pos[3])"""
        ret = self._wrap_call(self._vtk_obj.GetPoint1DisplayPosition, *args)
        return ret

    def set_point1display_position(self, *args):
        """
        V.set_point1display_position([float, float, float])
        C++: void SetPoint1DisplayPosition(double pos[3])"""
        ret = self._wrap_call(self._vtk_obj.SetPoint1DisplayPosition, *args)
        return ret

    label_position = traits.Float(0.5, enter_set=True, auto_set=False, help=\
        """
        Set/Get position of the label title in normalized coordinates
        [0,1]. 0 is at the start of the line whereas 1 is at the end.
        """
    )
    def _label_position_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetLabelPosition,
                        self.label_position)

    def get_point2display_position(self, *args):
        """
        V.get_point2display_position([float, float, float])
        C++: void GetPoint2DisplayPosition(double pos[3])"""
        ret = self._wrap_call(self._vtk_obj.GetPoint2DisplayPosition, *args)
        return ret

    def set_point2display_position(self, *args):
        """
        V.set_point2display_position([float, float, float])
        C++: void SetPoint2DisplayPosition(double pos[3])"""
        ret = self._wrap_call(self._vtk_obj.SetPoint2DisplayPosition, *args)
        return ret

    def get_point2_world_position(self, *args):
        """
        V.get_point2_world_position([float, float, float])
        C++: void GetPoint2WorldPosition(double pos[3])
        Methods to Set/Get the coordinates of the two points defining
        this representation. Note that methods are available for both
        display and world coordinates.
        """
        ret = self._wrap_call(self._vtk_obj.GetPoint2WorldPosition, *args)
        return ret

    def set_point2_world_position(self, *args):
        """
        V.set_point2_world_position([float, float, float])
        C++: void SetPoint2WorldPosition(double pos[3])
        Methods to Set/Get the coordinates of the two points defining
        this representation. Note that methods are available for both
        display and world coordinates.
        """
        ret = self._wrap_call(self._vtk_obj.SetPoint2WorldPosition, *args)
        return ret

    glyph_scale = traits.Float(1.0, enter_set=True, auto_set=False, help=\
        """
        Scale the glyphs used as tick marks. By default it is 1/40th of
        the length.
        """
    )
    def _glyph_scale_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetGlyphScale,
                        self.glyph_scale)

    def _get_glyph_actor(self):
        return wrap_vtk(self._vtk_obj.GetGlyphActor())
    glyph_actor = traits.Property(_get_glyph_actor, help=\
        """
        Convenience method to get the glyph actor. Using this it is
        possible to control the appearance of the glyphs.
        """
    )

    def _get_label_actor(self):
        return wrap_vtk(self._vtk_obj.GetLabelActor())
    label_actor = traits.Property(_get_label_actor, help=\
        """
        Convenience method Get the label actor. It is possible to control
        the appearance of the label.
        """
    )

    def _get_label_property(self):
        return wrap_vtk(self._vtk_obj.GetLabelProperty())
    label_property = traits.Property(_get_label_property, help=\
        """
        Get the distance annotation property
        """
    )

    def _get_line_property(self):
        return wrap_vtk(self._vtk_obj.GetLineProperty())
    line_property = traits.Property(_get_line_property, help=\
        """
        Convenience method to get the line actor property.
        """
    )

    def set_label_scale(self, *args):
        """
        V.set_label_scale(float, float, float)
        C++: void SetLabelScale(double x, double y, double z)
        V.set_label_scale([float, float, float])
        C++: virtual void SetLabelScale(double scale[3])
        Scale text (font size along each dimension). This helps control
        the appearance of the 3d text.
        """
        ret = self._wrap_call(self._vtk_obj.SetLabelScale, *args)
        return ret

    _updateable_traits_ = \
    (('allocated_render_time', 'GetAllocatedRenderTime'), ('handle_size',
    'GetHandleSize'), ('estimated_render_time', 'GetEstimatedRenderTime'),
    ('label_format', 'GetLabelFormat'), ('maximum_number_of_ruler_ticks',
    'GetMaximumNumberOfRulerTicks'), ('number_of_ruler_ticks',
    'GetNumberOfRulerTicks'), ('label_position', 'GetLabelPosition'),
    ('use_bounds', 'GetUseBounds'), ('ruler_mode', 'GetRulerMode'),
    ('render_time_multiplier', 'GetRenderTimeMultiplier'), ('glyph_scale',
    'GetGlyphScale'), ('ruler_distance', 'GetRulerDistance'),
    ('visibility', 'GetVisibility'), ('need_to_render',
    'GetNeedToRender'), ('reference_count', 'GetReferenceCount'),
    ('place_factor', 'GetPlaceFactor'), ('pickable', 'GetPickable'),
    ('tolerance', 'GetTolerance'), ('dragable', 'GetDragable'), ('debug',
    'GetDebug'), ('global_warning_display', 'GetGlobalWarningDisplay'))
    
    _full_traitnames_list_ = \
    (['debug', 'dragable', 'global_warning_display', 'need_to_render',
    'pickable', 'ruler_mode', 'use_bounds', 'visibility',
    'allocated_render_time', 'estimated_render_time', 'glyph_scale',
    'handle_size', 'label_format', 'label_position',
    'maximum_number_of_ruler_ticks', 'number_of_ruler_ticks',
    'place_factor', 'render_time_multiplier', 'ruler_distance',
    'tolerance'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(DistanceRepresentation3D, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            traitsui.View((traitsui.Item("handler._full_traits_list",show_label=False)),
            title='Edit DistanceRepresentation3D properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            traitsui.View((['need_to_render', 'ruler_mode', 'use_bounds',
            'visibility'], [], ['allocated_render_time', 'estimated_render_time',
            'glyph_scale', 'handle_size', 'label_format', 'label_position',
            'maximum_number_of_ruler_ticks', 'number_of_ruler_ticks',
            'place_factor', 'render_time_multiplier', 'ruler_distance',
            'tolerance']),
            title='Edit DistanceRepresentation3D properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            traitsui.View((traitsui.HGroup(traitsui.spring, "handler.view_type", show_border=True), 
            traitsui.Item("handler.info.object", editor = traitsui.InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit DistanceRepresentation3D properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

