# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui import api as traitsui

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

from tvtk.tvtk_classes.object import Object


class StringToImage(Object):
    """
    StringToImage - uses Qt to render the supplied text to an image.
    
    Superclass: Object
    
    
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkStringToImage, obj, update, **traits)
    
    scale_to_power_of_two = traits.Bool(False, help=\
        """
        Should we produce images at powers of 2, makes rendering on old
        open_gl hardware easier. Default is false.
        """
    )
    def _scale_to_power_of_two_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetScaleToPowerOfTwo,
                        self.scale_to_power_of_two)

    def get_bounds(self, *args):
        """
        V.get_bounds(TextProperty, unicode) -> Vector2i
        C++: virtual Vector2i GetBounds(TextProperty *property,
            const UnicodeString &string)
        V.get_bounds(TextProperty, string) -> Vector2i
        C++: virtual Vector2i GetBounds(TextProperty *property,
            const StdString &string)
        Given a text property and a string, get the bounding box [xmin,
        xmax] x [ymin, ymax]. Note that this is the bounding box of the
        area where actual pixels will be written, given a
        text/pen/baseline location of (0,0). For example, if the string
        starts with a 'space', or depending on the orientation, you can
        end up with a [-20, -10] x [5, 10] bbox (the math to get the real
        bbox is straightforward). Return 1 on success, 0 otherwise. You
        can use is_bounding_box_valid() to test if the computed bbox is
        valid (it may not if get_bounding_box() failed or if the string was
        empty).
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.GetBounds, *my_args)
        return wrap_vtk(ret)

    def render_string(self, *args):
        """
        V.render_string(TextProperty, unicode, ImageData) -> int
        C++: virtual int RenderString(TextProperty *property,
            const UnicodeString &string, ImageData *data)
        V.render_string(TextProperty, string, ImageData) -> int
        C++: virtual int RenderString(TextProperty *property,
            const StdString &string, ImageData *data)
        Given a text property and a string, this function initializes the
        ImageData *data and renders it in a ImageData.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.RenderString, *my_args)
        return ret

    _updateable_traits_ = \
    (('reference_count', 'GetReferenceCount'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('scale_to_power_of_two', 'GetScaleToPowerOfTwo'))
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'scale_to_power_of_two'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(StringToImage, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            traitsui.View((traitsui.Item("handler._full_traits_list",show_label=False)),
            title='Edit StringToImage properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            traitsui.View(([], [], ['scale_to_power_of_two']),
            title='Edit StringToImage properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            traitsui.View((traitsui.HGroup(traitsui.spring, "handler.view_type", show_border=True), 
            traitsui.Item("handler.info.object", editor = traitsui.InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit StringToImage properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

